#include "config.h"
#include "test.h"
#include "libvmma/libvmma.h"
#include <stdio.h>

int main(int argc, char* argv[])
{
	int i, j;

	puts("Test 1: start");
	{
		if(0!=test_buddy(0, 100)) { return 1; }
		if(0!=test_buddy(0, 1000)) { return 1; }
		if(0!=test_buddy(0, 10000)) { return 1; }
	}
	puts("Test 1: passed");

	puts("Test 2: start");
	{
		if(0!=test_buddy(1, 100)) { return 1; }
		if(0!=test_buddy(1, 1000)) { return 1; }
		if(0!=test_buddy(1, 10000)) { return 1; }
	}
	puts("Test 2: passed");

	puts("Test 3: start");
	{
		if(0!=test_vmma(0, 1, 100)) { return 1; }
		if(0!=test_vmma(0, 2, 100)) { return 1; }
		if(0!=test_vmma(VMMA_FL_MINGROWTH, 1, 100)) { return 1; }
		if(0!=test_vmma(VMMA_FL_MINGROWTH, 2, 100)) { return 1; }
		if(0!=test_vmma(VMMA_FL_MULTITHREADED, 1, 100)) { return 1; }
		if(0!=test_vmma(VMMA_FL_MULTITHREADED, 2, 100)) { return 1; }
		if(0!=test_vmma(VMMA_FL_KEEPCACHED, 1, 100)) { return 1; }
		if(0!=test_vmma(VMMA_FL_KEEPCACHED, 2, 100)) { return 1; }
	}
	puts("Test 3: passed");

	puts("Test 4: start");
	{
		for(i=5;i<=100;i+=5)
		{
			for(j=1;j<=5;++j)
			{
				if(0!=test_buddy2(0, 0, 0, j, i)) { return 1; }
				if(0!=test_buddy2(0, 0, 1, j, i)) { return 1; }
				if(0!=test_buddy2(0, 1, 0, j, i)) { return 1; }
				if(0!=test_buddy2(0, 1, 1, j, i)) { return 1; }
				if(0!=test_buddy2(1, 0, 0, j, i)) { return 1; }
				if(0!=test_buddy2(1, 0, 1, j, i)) { return 1; }
				if(0!=test_buddy2(1, 1, 0, j, i)) { return 1; }
				if(0!=test_buddy2(1, 1, 1, j, i)) { return 1; }
			}
			putchar('.');
		}
		putchar('\n');
	}
	puts("Test 4: passed");

	puts("==== All tests passed ====");
	return 0;
}
